/*****************************************************************
******************************************************************
**            Ch Example for the K8055 USB I/O Card             **
**                                                              **
**               Copyright RE-Applications  2006                **
**                    www.RE-Applications.be                    **
**                                                              **
**                                                              **
**                         Developed by                         **
**                       RE-Applications                        **
**                   www.RE-Applications.be                     **
******************************************************************
******************************************************************/

#include <windows.h>
#include <Commctrl.h>
#include <K8055D_C.h>
#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "K8055_Demo.h"

HWND hwnd;                                                              // Dialog
HWND lngScrAD1;                                                         // Scrollbar DA1
HWND lngScrAD2;                                                         // Scrollbar DA2
HWND lngScrDA1;                                                         // Scrollbar AD1
HWND lngScrDA2;                                                         // Scrollbar AD2

char strBuffer[5];                                                      // Convertion buffer for string output
int bConnected;                                                         // Indicates if a card is connected
long lngDigValue;                                                       // Temp. digital value for the output test
long lngVScroll;                                                        // Scroll values
int intCount;                                                           // Iteration counter
int intCurrentCard;                                                     // Current connected card
int bMulticardExample;                                                  // Multicard flag

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow) {
    static char szAppName[] = "K8055 Demo" ;
    HWND        hDlg;
    HWND        hCtl;
    MSG         msg;
    WNDCLASSEX  wndclass;
    int hFont;
    
    hFont = (int)GetStockObject(ANSI_VAR_FONT);

    wndclass.cbSize        = sizeof(wndclass);
    wndclass.style         = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc   = WndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)GetSysColorBrush(COLOR_BTNFACE);
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = szAppName;
    wndclass.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    
    RegisterClassEx (&wndclass);

    hDlg = CreateWindowEx(WS_EX_DLGMODALFRAME | WS_EX_CONTROLPARENT | WS_EX_WINDOWEDGE, szAppName, "K8055 Ch Example", 
            WS_POPUP | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CAPTION | WS_SYSMENU | DS_3DLOOK | DS_SETFONT | DS_MODALFRAME, 
            (GetSystemMetrics(SM_CXSCREEN) - 734) / 2, (GetSystemMetrics(SM_CYSCREEN) - 372) / 2, 734, 372, 0, 0, GetModuleHandle(""), NULL);

    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Connect", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 11, 57, 104, 26, hDlg, (HMENU)IDC_BTNCONNECT, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Set All Digital", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 11, 176, 114, 23, hDlg, (HMENU)IDC_BTNSETALLDIG, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Clear All Digital", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 11, 203, 114, 21, hDlg, (HMENU)IDC_BTNRESERALLDIG, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "---", WS_CHILD | WS_VISIBLE | WS_GROUP, 11, 88, 90, 16, hDlg, (HMENU)IDC_LBLCONNECT, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Set All Analog", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 11, 234, 114, 23, hDlg, (HMENU)IDC_BTNSETALLANA, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Clear All Analog", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 11, 260, 114, 23, hDlg, (HMENU)IDC_BTNRESETALLANA, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Output Test", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX | BS_PUSHLIKE, 11, 294, 113, 34, hDlg, (HMENU)IDC_CHKOUTPUTTEST, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Outputs", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 342, 67, 249, 55, hDlg, (HMENU)IDC_FRAOUT, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "1", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 353, 89, 26, 16, hDlg, (HMENU)IDC_CHKOUT0, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "2", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 381, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "3", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 410, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "4", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 440, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT3, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "5", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 467, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT4, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "6", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 495, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT5, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "7", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 524, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT6, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "8", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 552, 89, 24, 16, hDlg, (HMENU)IDC_CHKOUT7, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Inputs", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 341, 10, 168, 55, hDlg, (HMENU)IDC_FRAIN, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "1", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 357, 33, 26, 16, hDlg, (HMENU)IDC_CHKIN0, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "2", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 386, 33, 24, 16, hDlg, (HMENU)IDC_CHKIN1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "3", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 414, 33, 24, 16, hDlg, (HMENU)IDC_CHKIN2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "4", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 444, 33, 24, 16, hDlg, (HMENU)IDC_CHKIN3, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "5", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 471, 33, 24, 16, hDlg, (HMENU)IDC_CHKIN4, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "DA1", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 144, 10, 41, 319, hDlg, (HMENU)IDC_FRADA1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "ScrollBar", NULL, WS_CHILD | WS_VISIBLE | SBS_VERT, 156, 29, 15, 271, hDlg, (HMENU)IDC_SCRLDA1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "DA2", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 191, 10, 41, 319, hDlg, (HMENU)IDC_FRADA2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "ScrollBar", NULL, WS_CHILD | WS_VISIBLE | SBS_VERT, 203, 29, 15, 271, hDlg, (HMENU)IDC_SCRLDA2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "AD2", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 287, 10, 41, 319, hDlg, (HMENU)IDC_FRAAD2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "ScrollBar", NULL, WS_CHILD | WS_VISIBLE | SBS_VERT, 299, 29, 15, 271, hDlg, (HMENU)IDC_SCRLAD2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Card Address", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 11, 10, 104, 44, hDlg, (HMENU)IDC_FRAADDRESS, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "SK5", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 20, 31, 44, 18, hDlg, (HMENU)IDC_CHKSK5, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "SK6", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, 65, 31, 44, 18, hDlg, (HMENU)IDC_CHKSK6, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Counter 1", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 342, 130, 119, 198, hDlg, (HMENU)IDC_FRACOUNTER1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Counter 2", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 464, 130, 126, 198, hDlg, (HMENU)IDC_FRACOUNTER2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "0", WS_CHILD | WS_VISIBLE | WS_GROUP | SS_CENTER, 149, 306, 27, 15, hDlg, (HMENU)IDC_LBLDA1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "0", WS_CHILD | WS_VISIBLE | WS_GROUP | SS_CENTER, 197, 306, 27, 15, hDlg, (HMENU)IDC_LBLDA2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "0", WS_CHILD | WS_VISIBLE | WS_GROUP | SS_CENTER, 245, 306, 27, 15, hDlg, (HMENU)IDC_LBLAD1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "0", WS_CHILD | WS_VISIBLE | WS_GROUP | SS_CENTER, 293, 306, 27, 15, hDlg, (HMENU)IDC_LBLAD2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_NOPARENTNOTIFY, "Edit", NULL, WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_CENTER, 354, 154, 93, 20, hDlg, (HMENU)IDC_TXTCOUNTER1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_NOPARENTNOTIFY, "Edit", NULL, WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_CENTER, 483, 154, 93, 20, hDlg, (HMENU)IDC_TXTCOUNTER2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Reset", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 354, 184, 93, 23, hDlg, (HMENU)IDC_BTNRESETCOUNTER1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Reset", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 483, 184, 93, 23, hDlg, (HMENU)IDC_BTNRESETCOUNTER2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "Debounce Time", WS_CHILD | WS_VISIBLE | WS_GROUP, 363, 215, 90, 15, hDlg, (HMENU)IDC_LBLDEBOUNCETIME1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "Debounce Time", WS_CHILD | WS_VISIBLE | WS_GROUP, 489, 215, 90, 15, hDlg, (HMENU)IDC_LBLDEBOUNCETIME2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "0ms", WS_CHILD | WS_VISIBLE | WS_GROUP | WS_TABSTOP | BS_AUTORADIOBUTTON, 357, 236, 84, 18, hDlg, (HMENU)IDC_OPT0MS1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "2ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 357, 255, 84, 18, hDlg, (HMENU)IDC_OPT2MS1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "1000ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 357, 296, 84, 18, hDlg, (HMENU)IDC_OPT1000MS1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "100ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 357, 275, 84, 18, hDlg, (HMENU)IDC_OPT100MS1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "0ms", WS_CHILD | WS_VISIBLE | WS_GROUP | WS_TABSTOP | BS_AUTORADIOBUTTON, 483, 237, 84, 18, hDlg, (HMENU)IDC_OPT0MS2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "2ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 483, 257, 84, 18, hDlg, (HMENU)IDC_OPT2MS2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "100ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 483, 276, 84, 18, hDlg, (HMENU)IDC_OPT100MS2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "1000ms", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 483, 297, 84, 18, hDlg, (HMENU)IDC_OPT1000MS2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Multicard Commands", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 594, 10, 123, 319, hDlg, (HMENU)IDC_FRAMULTICARD, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Find Devices", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 605, 215, 101, 26, hDlg, (HMENU)IDC_BTNFINDDEVICES, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Static", "Set Current Device", WS_CHILD | WS_VISIBLE | WS_GROUP, 609, 49, 93, 15, hDlg, (HMENU)IDC_LBLCURRENTDEVICE, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Device 0", WS_CHILD | WS_VISIBLE | WS_GROUP | BS_AUTORADIOBUTTON, 621, 86, 75, 15, hDlg, (HMENU)IDC_OPTDEVICE0, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Device 1", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 621, 114, 75, 15, hDlg, (HMENU)IDC_OPTDEVICE1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Device 2", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 621, 145, 75, 15, hDlg, (HMENU)IDC_OPTDEVICE2, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Device 3", WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 621, 177, 75, 15, hDlg, (HMENU)IDC_OPTDEVICE3, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "DLL Version", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 605, 293, 101, 24, hDlg, (HMENU)IDC_BTNDLLVERSION, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "ScrollBar", NULL, WS_CHILD | WS_VISIBLE | SBS_VERT, 251, 29, 15, 271, hDlg, (HMENU)IDC_SCRLAD1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "Output Test", WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_TABSTOP | BS_AUTOCHECKBOX | BS_PUSHLIKE, 605, 254, 101, 24, hDlg, (HMENU)IDC_CHKOUTPUTTEST1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
    hCtl = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "Button", "AD1", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 239, 10, 41, 319, hDlg, (HMENU)IDC_FRAAD1, GetModuleHandle(""), NULL);
    if (hFont) SendMessage(hCtl, WM_SETFONT, hFont, 0); 
        
    SendMessage(GetDlgItem(hDlg, IDC_OPT0MS1), BM_SETCHECK, BST_CHECKED, 0);
    SendMessage(GetDlgItem(hDlg, IDC_OPT0MS2), BM_SETCHECK, BST_CHECKED, 0);
    ShowWindow (hDlg, iCmdShow) ;
    UpdateWindow (hDlg) ;
    while (GetMessage (&msg, NULL, 0, 0))
      {
      TranslateMessage (&msg) ;
      DispatchMessage (&msg) ;
      }
    return msg.wParam ;
}

void ltoa (UINT intNumber, char strBuf[], int intMode) {
    int intOffset;
    switch (intMode) {
        case 16: //Isn't needed here but could be useful
            intOffset = sprintf(strBuf, "%x", intNumber);
            break;
        default:
            intOffset = sprintf(strBuf, "%d", intNumber);
    }    
	strBuf[intOffset] = '\0';
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

    if (lngScrDA1 == 0) {
        //Init the scrollbar handles
        //The "WM_INITDIALOG" isn't fired?? This code gets the scrollbars initialized, 
        //normally this code should be in the WM_INITDIALOG message.
        lngDigValue = -1;                                                   // Set begin value
        intCurrentCard = 0;
        lngScrDA1 = GetDlgItem(hwnd, IDC_SCRLDA1);                          // Get the scrollbar handle
        SendMessage(lngScrDA1, SBM_SETRANGE, 0, 255);                       // Set ranges 0-255
        SendMessage(lngScrDA1, SBM_SETPOS, 255, true);                      // Set the slider position
        lngScrDA2 = GetDlgItem(hwnd, IDC_SCRLDA2);
        SendMessage(lngScrDA2, SBM_SETRANGE, 0, 255);
        SendMessage(lngScrDA2, SBM_SETPOS, 255, true);
        lngScrAD1 = GetDlgItem(hwnd, IDC_SCRLAD1);
        SendMessage(lngScrAD1, SBM_SETRANGE, 0, 255);
        SendMessage(lngScrAD1, SBM_SETPOS, 255, true);
        lngScrAD2 = GetDlgItem(hwnd, IDC_SCRLAD2);
        SendMessage(lngScrAD2, SBM_SETRANGE, 0, 255);
        SendMessage(lngScrAD2, SBM_SETPOS, 255, true);
        CheckDlgButton(hwnd, IDC_OPT0MS1, BST_CHECKED);                         // Set the 0ms option buttons
        CheckDlgButton(hwnd, IDC_OPT0MS2, BST_CHECKED);
        EnableWindow(GetDlgItem(hwnd, IDC_CHKOUTPUTTEST1), false);    
    }    

    switch (iMsg) {
        case WM_VSCROLL:
			if ((HWND)lParam == lngScrDA1){                                 // If scrollbar DA1 is changed
				if (LOWORD(wParam) == SB_THUMBTRACK)                        // Only slidebar changes
					lngVScroll = (HIWORD(wParam));                          // Get the value
				SendMessage(lngScrDA1, SBM_SETPOS, lngVScroll, true);       // Set the slider position
				OutputAnalogChannel(1, 255 - lngVScroll);                   // Write the analog card channel
   				ltoa(255 - lngVScroll, strBuffer, 10);
                SetDlgItemText(hwnd, IDC_LBLDA1, strBuffer);
			}
			if ((HWND)lParam == lngScrDA2) {                                //   ""  Same for scrollbar DA2
				if (LOWORD(wParam) == SB_THUMBTRACK)
					lngVScroll = (HIWORD(wParam));
				SendMessage(lngScrDA2, SBM_SETPOS, lngVScroll, true);
				OutputAnalogChannel(2, 255 - lngVScroll);
   				ltoa(255 - lngVScroll, strBuffer, 10);
                SetDlgItemText(hwnd, IDC_LBLDA2, strBuffer);
			}
			break;
		case WM_CLOSE:
			KillTimer(hwnd, IDT_TIMERPOL);                                  // Close timers
			KillTimer(hwnd, IDT_TIMERTEST);
			CloseDevice();                                                  // Close the device connection (if any)
            PostQuitMessage(0);
			return 0;
            break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_BTNDLLVERSION:                                     // Shows the Dll Version dialog
					Version();
					break;
                case IDC_BTNCONNECT:
                    long lngValue;                                          // Some declarations
                    int bSK5;
                    int bSK6;
                    long lngReturn;
    
                    if (IsDlgButtonChecked(hwnd, IDC_CHKSK5) == BST_CHECKED) bSK5 = false;// Read address 5
                        else bSK5 = true;
                    if (IsDlgButtonChecked(hwnd, IDC_CHKSK6) == BST_CHECKED) bSK6 = false;// read address 6
                        else bSK6 = true;
    
                    lngValue = bSK5 + (bSK6 * 2);                           // Calculate the device value
                    lngReturn = OpenDevice(lngValue);                       // Open the device
                    
                    if (lngReturn == lngValue) {                            // If the return value is valid
                        SetDlgItemText(hwnd, IDC_LBLCONNECT, "Device found");// Set the connection label
                        bConnected = true;                                  // Set the connection flag
                        SetTimer(hwnd, IDT_TIMERPOL, 10, 0);                // Initiate timer
                    }
                    else {                                                  // No card was found
                        SetDlgItemText(hwnd, IDC_LBLCONNECT, "No Device found");
                        bConnected = false;
                    }
                    break;
				case IDC_BTNSETALLDIG:                                      // Set all digital button
					if (bConnected) {
						SetAllDigital();                                    // Set all digital card outputs
						for(intCount = 0; intCount < 8; intCount++)		
							CheckDlgButton(hwnd, IDC_CHKOUT0 + intCount, 1);// Set the output checkboxes
					}
					break;
				case IDC_BTNRESERALLDIG:                                    // Reset (Clear) all digital button
					if (bConnected)	{ 
						ClearAllDigital();                                  // Clear aal digital card outputs
						for(intCount = 0; intCount < 8; intCount++)
							CheckDlgButton(hwnd, IDC_CHKOUT0 + intCount, 0);
					}
					break;
				case IDC_BTNSETALLANA:                                      // Set all analog channels
					if (bConnected)	{
						SetAllAnalog();				
						SendMessage(lngScrDA1, SBM_SETPOS, 0, true);        // Set slider positions on max. value
						SendMessage(lngScrDA2, SBM_SETPOS, 0, true);
						SetDlgItemText(hwnd, IDC_LBLDA1, "255");            // Set item text 255
						SetDlgItemText(hwnd, IDC_LBLDA2, "255");
					}
					break;
				case IDC_BTNRESETALLANA:                                    // Rest (Clear) all analog channels
					if (bConnected) {
						ClearAllAnalog();
						SendMessage(lngScrDA1, SBM_SETPOS, 255, true);      // Set slider positions on min. value
						SendMessage(lngScrDA2, SBM_SETPOS, 255, true);
						SetDlgItemText(hwnd, IDC_LBLDA1, "0");
						SetDlgItemText(hwnd, IDC_LBLDA2, "0");
					}
					break;
				case IDC_CHKOUTPUTTEST:                                     // Output test button
					if (bConnected) {
						if (IsDlgButtonChecked(hwnd, IDC_CHKOUTPUTTEST) == BST_CHECKED) 
							SetTimer(hwnd, IDT_TIMERTEST, 100, 0);          // Set test timer
							else KillTimer(hwnd, IDT_TIMERTEST);            // Delete test timer
					}
					break;
				case IDC_CHKOUTPUTTEST1:
					if (bConnected) {
						if (IsDlgButtonChecked(hwnd, IDC_CHKOUTPUTTEST1) == BST_CHECKED) {
							bMulticardExample = true;                       // Set multicard example flag
							SetTimer(hwnd, IDT_TIMERTEST, 100, 0);

						} else { 
							bMulticardExample = false;
							KillTimer(hwnd, IDT_TIMERTEST);
						}	
					}
					break;
				case IDC_BTNRESETCOUNTER1:                                  // Reset couter 1 button
					if (bConnected) ResetCounter(1);                        // Resetcounter 1 command
					break;
				case IDC_BTNRESETCOUNTER2:
					if (bConnected) ResetCounter(2);
					break;
				case IDC_CHKOUT0:; case IDC_CHKOUT1:; case IDC_CHKOUT2:; case IDC_CHKOUT3:
				case IDC_CHKOUT4:; case IDC_CHKOUT5:; case IDC_CHKOUT6:; case IDC_CHKOUT7:
					if (bConnected) {                                       // Set the output if the checkbox is checked
						if ((IsDlgButtonChecked(hwnd, LOWORD(wParam)) == BST_CHECKED) && bConnected)
							SetDigitalChannel(LOWORD(wParam) - IDC_CHKOUT0 + 1);// Set output on card
							else ClearDigitalChannel(LOWORD(wParam) - IDC_CHKOUT0 + 1);// Reset output
					}
					break;
				case IDC_OPT0MS1:                                           // Select the debounce counter 1
					if (bConnected) SetCounterDebounceTime(1, 0);           // 0ms
					break;
				case IDC_OPT2MS1:
					if (bConnected) SetCounterDebounceTime(1, 2);           // 2ms
					break;
				case IDC_OPT100MS1:
					if (bConnected) SetCounterDebounceTime(1, 100);         // 100ms
					break;
				case IDC_OPT1000MS1:
					if (bConnected) SetCounterDebounceTime(1, 1000);        // 1000ms
					break;
				case IDC_OPT0MS2:
					if (bConnected) SetCounterDebounceTime(2, 0);
					break;
				case IDC_OPT2MS2:
					if (bConnected) SetCounterDebounceTime(2, 2);
					break;
				case IDC_OPT100MS2:
					if (bConnected) SetCounterDebounceTime(2, 100);
					break;
				case IDC_OPT1000MS2:
					if (bConnected) SetCounterDebounceTime(2, 1000);
					break;
				case IDC_BTNFINDDEVICES:                                    // Find the devixes button
					int intDevices;
					int bChecked;
					bChecked = false;
					intDevices = SearchDevices();                           // Find devices command
					if (intDevices) {                                       // If any device was found
						bConnected = true;                                  // Set flag
						EnableWindow(GetDlgItem(hwnd, IDC_BTNCONNECT), false);// Disable buttons
						EnableWindow(GetDlgItem(hwnd, IDC_BTNFINDDEVICES), false);
						EnableWindow(GetDlgItem(hwnd, IDC_CHKOUTPUTTEST1), true);
						SetTimer(hwnd, IDT_TIMERPOL, 10, 0);                // Start timer
					}
					else bConnected = false;
					if ((int)(intDevices & 1) == 1) {                      // Device 0 = connected
						EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE0), true);// Enable the radio button
						if (!bChecked) {
							CheckDlgButton(hwnd, IDC_OPTDEVICE0, 1);        // Set radio button check
							SetCurrentDevice (0);                           // Set the current device command
							bChecked = true;
						}
					} else EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE0), false);// Disable radio button
					if ((int)(intDevices & 2) == 2) {                      // Device 1= connected
						EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE1), true);
						if (!bChecked) {
							CheckDlgButton(hwnd, IDC_OPTDEVICE1, 1);        // Set radio button check
							SetCurrentDevice (1);
							bChecked = true;
						}
					} else EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE1), false);
					if ((int)(intDevices & 4) == 4) {                      // Device 2= connected
						EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE2), true);
						if (!bChecked) {
							CheckDlgButton(hwnd, IDC_OPTDEVICE2, 1);        // Set radio button check
							SetCurrentDevice (2);
							bChecked = true;
						}
					} else EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE2), false);
					if ((int)(intDevices & 8) == 8) {                      // Device 3= connected
						EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE3), true);
						if (!bChecked) {
							CheckDlgButton(hwnd, IDC_OPTDEVICE3, 1);        // Set radio button check
							SetCurrentDevice (3);
							bChecked = true;
						}
					} else EnableWindow(GetDlgItem(hwnd, IDC_OPTDEVICE3), false);
					break;
				case IDC_OPTDEVICE0:; case IDC_OPTDEVICE1:; case IDC_OPTDEVICE2:; case IDC_OPTDEVICE3:
					SetCurrentDevice(LOWORD(wParam) - IDC_OPTDEVICE0);      // Set device
					break;
            }
            break;
		case WM_TIMER:                                                      // Timer event
			if (LOWORD(wParam) == IDT_TIMERPOL) {
				long lngInputs;                                             // Some local declares
				long lngAna1;
				long lngAna2;
				KillTimer(hwnd, IDT_TIMERPOL);                              // Close the timer to prevent multiple events

				lngInputs = ReadAllDigital();                               // Read all digital inputs
				CheckDlgButton(hwnd, IDC_CHKIN0, lngInputs & 1);            // Set checkboxes
				CheckDlgButton(hwnd, IDC_CHKIN1, (lngInputs & 2) / 2);
				CheckDlgButton(hwnd, IDC_CHKIN2, (lngInputs & 4) / 4);
				CheckDlgButton(hwnd, IDC_CHKIN3, (lngInputs & 8) / 8);
				CheckDlgButton(hwnd, IDC_CHKIN4, (lngInputs & 16) / 16);
				
				ReadAllAnalog(&lngAna1, &lngAna2);                          // Read all analog values
				SendMessage(lngScrAD1, SBM_SETPOS, 255 - lngAna1, true);    // Set slider AD1
				SendMessage(lngScrAD2, SBM_SETPOS, 255 - lngAna2, true);    // Set slider AD2

				ltoa(ReadCounter(1), strBuffer, 10);                        // Convert counter 1 value to string values
				SetDlgItemText(hwnd, IDC_TXTCOUNTER1, strBuffer);           // Set the counter 1 textbox value
				ltoa(ReadCounter(2), strBuffer, 10);					
				SetDlgItemText(hwnd, IDC_TXTCOUNTER2, strBuffer);

				ltoa(lngAna1, strBuffer, 10);                               // Convert analog 1 to string values
				SetDlgItemText(hwnd, IDC_LBLAD1, strBuffer);                // Set the analog 1 value label
				ltoa(lngAna2, strBuffer, 10);
				SetDlgItemText(hwnd, IDC_LBLAD2, strBuffer);
				SetTimer(hwnd, IDT_TIMERPOL, 10, 0);
			}
			if (LOWORD(wParam) == IDT_TIMERTEST) {                          // Timer event output test
				if (bConnected) {                                           // Only if a card is connected
					CheckDlgButton(hwnd, IDC_CHKOUT0 + lngDigValue, BST_UNCHECKED);// Uncheck the checkbox
					ClearDigitalChannel(lngDigValue + 1);                   // Clear the digital card output
					lngDigValue++;                                          // Increase the position value
					if (lngDigValue == 8) {
						lngDigValue = 0;                                    // If position value = 8 then begin from start
						if (bMulticardExample) {
                            NextCard:                                       // Look for the next connected card
							CheckDlgButton(hwnd, IDC_OPTDEVICE0 + intCurrentCard, 0);// Uncheck optionbox
							intCurrentCard++;                               // Increase address number
							if (intCurrentCard == 4) intCurrentCard = 0;
							if (IsWindowEnabled(GetDlgItem(hwnd, IDC_OPTDEVICE0 + intCurrentCard))) {
									SetCurrentDevice(intCurrentCard);       // Set device
									CheckDlgButton(hwnd, IDC_OPTDEVICE0 + intCurrentCard, 1);// Check optionbox
							}
							else goto NextCard;
						}
					}
					SetDigitalChannel(lngDigValue + 1);                     // Set the digital card output
					CheckDlgButton(hwnd, IDC_CHKOUT0 + lngDigValue, BST_CHECKED);// Check the checkbox
				}
			}
			break;        
     }
     return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}
