#include <K8055D_C.h>
#include <ch.h>

EXPORTCH long OpenDevice_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long CardAddress;
    long retval;

    Ch_VaStart(interp, ap, varg);
    CardAddress = Ch_VaArg(interp, ap, long);
    retval = OpenDevice(CardAddress);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH void CloseDevice_chdl(void *varg) {
    CloseDevice();
}

EXPORTCH long ReadAnalogChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;
    long retval;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    retval = ReadAnalogChannel(Channel);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH void ReadAllAnalog_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long *Data1;
    long *Data2;

    Ch_VaStart(interp, ap, varg);
    Data1 = Ch_VaArg(interp, ap, long *);
    Data2 = Ch_VaArg(interp, ap, long *);
    ReadAllAnalog(Data1, Data2);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void OutputAnalogChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;
    long Data;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    Data = Ch_VaArg(interp, ap, long);
    OutputAnalogChannel(Channel, Data);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void OutputAllAnalog_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Data1;
    long Data2;

    Ch_VaStart(interp, ap, varg);
    Data1 = Ch_VaArg(interp, ap, long);
    Data2 = Ch_VaArg(interp, ap, long);
    OutputAllAnalog(Data1, Data2);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void ClearAnalogChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    ClearAnalogChannel(Channel);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void ClearAllAnalog_chdl(void *varg) {
    ClearAllAnalog();
}

EXPORTCH void SetAnalogChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    SetAnalogChannel(Channel);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void SetAllAnalog_chdl(void *varg) {
    SetAllAnalog();
}

EXPORTCH void WriteAllDigital_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Data;

    Ch_VaStart(interp, ap, varg);
    Data = Ch_VaArg(interp, ap, long);
    WriteAllDigital(Data);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void ClearDigitalChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    ClearDigitalChannel(Channel);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void ClearAllDigital_chdl(void *varg) {
    ClearAllDigital();
}

EXPORTCH void SetDigitalChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    SetDigitalChannel(Channel);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void SetAllDigital_chdl(void *varg) {
    SetAllDigital();
}

EXPORTCH bool ReadDigitalChannel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long Channel;
    bool retval;

    Ch_VaStart(interp, ap, varg);
    Channel = Ch_VaArg(interp, ap, long);
    retval = ReadDigitalChannel(Channel);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH long ReadAllDigital_chdl(void *varg) {
    long retval;
    retval = ReadAllDigital();
    return retval;
}

EXPORTCH long ReadCounter_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long CounterNr;
    long retval;

    Ch_VaStart(interp, ap, varg);
    CounterNr = Ch_VaArg(interp, ap, long);
    retval = ReadCounter(CounterNr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH void ResetCounter_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long CounterNr;

    Ch_VaStart(interp, ap, varg);
    CounterNr = Ch_VaArg(interp, ap, long);
    ResetCounter(CounterNr);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void SetCounterDebounceTime_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long CounterNr;
    long DebounceTime;

    Ch_VaStart(interp, ap, varg);
    CounterNr = Ch_VaArg(interp, ap, long);
    DebounceTime = Ch_VaArg(interp, ap, long);
    SetCounterDebounceTime(CounterNr, DebounceTime);
    Ch_VaEnd(interp, ap);
}

EXPORTCH void Version_chdl(void *varg) {
    Version();
}

EXPORTCH long SearchDevices_chdl(void *varg) {
    long retval;
    retval = SearchDevices();
    return retval;
}

EXPORTCH long SetCurrentDevice_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    long lngCardAddress;
    long retval;

    Ch_VaStart(interp, ap, varg);
    lngCardAddress = Ch_VaArg(interp, ap, long);
    retval = SetCurrentDevice(lngCardAddress);
    Ch_VaEnd(interp, ap);
    return retval;
}
